


computeMW_PS1d = function(mt,Ct,xt){
  M = c(mt,a+b*mt,mt,ax+bx*xt)
  W = matrix(0,4,4)
  W[1,1] = Ct
  W[2,2] = b^2*Ct+Sigma[2,2]
  W[3,3] = Ct+Sigma[1,1]
  W[4,4] = Sigma[3,3]
 	W[1,2] = W[2,1] = b*Ct
 	W[1,3] = W[3,1] = Ct
 	W[2,3] = W[3,2] = b*Ct+Sigma[1,2]
 	W[2,4] = W[4,2] = Sigma[2,3]
 	W[3,4] = W[4,3] = Sigma[1,3]
 	return(list(M=M,W=W))
}


#######################################
#######################################
computemC_PS1d = function(M,W,t){
  P = W[1:2,3:4]%*%solve(W[3:4,3:4])
  R = W[1:2,1:2]-P%*%W[3:4,1:2]
  if (t>1){
  	  A = M[1:2] + P%*%	c(r[t]-M[1],x[t]-ax-bx*x[t-1])
  	}else{
  	  A = M[1:2] + P%*%	c(r[t]-m0,x[t]-ax-bx*x0)
  	}
  return(list(mt=A[2],Ct=R[2,2]))
}


#######################################
#######################################
sampleMU_PS1d = function(M,W,mu,t){
  P   = W[1,2:4]%*%solve(W[2:4,2:4])
  H   = W[1,1]-P%*%W[2:4,1]
  	h   = M[1] + P%*%	c(mu-a-b*M[1],r[t+1]-M[1],x[t+1]-ax-bx*x[t])
  out = rnorm(1,h,sqrt(H))
  return(out)
}

#######################################
#######################################
	
sampleCOEF_MU = function(MU,Sigma,m0,C0){
	MU = as.matrix(MU)
	res= cbind(R[2:n] - MU[1:(n-1)],x[2:n] - ax - bx*x[1:(n-1)])
    
    Sig.2 = matrix(c(Sigma[2,1],Sigma[2,3]),1,2,byrow=T)
	Y = MU[2:n] - (Sig.2%*%solve(Sigma[c(1,3),c(1,3)]))%*%t(res) 
	F = cbind(1,MU[1:(n-1)])
	
	W = Sigma[2,2] - Sig.2%*%solve(Sigma[c(1,3),c(1,3)])%*%t(Sig.2)
	
	V1 = solve(t(F)%*%F/as.numeric(W) + solve(C0))
	M1 = V1%*%(t(F)%*%t(Y)/as.numeric(W) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}

#######################################
#######################################

sampleCOEF_X = function(MU,Sigma,m0,C0){
	auxMU = as.matrix(MU)
	res= cbind(R[2:n] - auxMU[1:(n-1)],auxMU[2:n] - a - b*auxMU[1:(n-1)])
    
    Sig.3 = matrix(c(Sigma[3,1],Sigma[2,3]),1,2,byrow=T)
	Y = x[2:n] - (Sig.3%*%solve(Sigma[c(1,2),c(1,2)]))%*%t(res) 
	F = cbind(1,x[1:(n-1)])
	
	W = Sigma[3,3] - Sig.3%*%solve(Sigma[c(1,2),c(1,2)])%*%t(Sig.3)
	
	V1 = solve(t(F)%*%F/as.numeric(W) + solve(C0))
	M1 = V1%*%(t(F)%*%t(Y)/as.numeric(W) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}

#######################################
#######################################
computeMW_PS3d_TV = function(mt,Ct,xt,Sigma){
  M = c(mt,a+b*mt,mt,ax1+bx1*xt[1],ax2+bx2*xt[2],ax3+bx3*xt[3])
  W = matrix(0,6,6)
  W[1,1] = Ct
  W[2,2] = b^2*Ct+Sigma[2,2]
  W[3,3] = Ct+Sigma[1,1]
  W[4,4] = Sigma[3,3]
  W[5,5] = Sigma[4,4]
  W[6,6] = Sigma[5,5]
  
 	W[1,2] = W[2,1] = b*Ct
 	W[1,3] = W[3,1] = Ct
 	
 	W[2,3] = W[3,2] = b*Ct+Sigma[1,2]
 	W[2,4] = W[4,2] = Sigma[2,3]
 	W[2,5] = W[5,2] = Sigma[2,4]
 	W[2,6] = W[6,2] = Sigma[2,5]
 	
 	W[3,4] = W[4,3] = Sigma[1,3]
 	W[3,5] = W[5,3] = Sigma[1,4]
 	W[3,6] = W[6,3] = Sigma[1,5]
 	
 	W[4,5] = W[5,4] = Sigma[3,4]
 	W[4,6] = W[6,4] = Sigma[3,5]
 	
 	W[5,6] = W[6,5] = Sigma[4,5]
 	
  	return(list(M=M,W=W))
}


#######################################
#######################################
computemC_PS3d = function(M,W,t){
  P = W[1:2,3:6]%*%solve(W[3:6,3:6])
  R = W[1:2,1:2]-P%*%W[3:6,1:2]
  if (t>1){
  	  A = M[1:2] + P%*%	c(r[t]-M[1],x[t,1]-ax1-bx1*x[t-1,1],x[t,2]-ax2-bx2*x[t-1,2],x[t,3]-ax3-bx3*x[t-1,3])
  	}else{
  	  A = M[1:2] + P%*%	c(r[t]-m0,x[t,1]-ax1-bx1*x0[1],x[t,2]-ax2-bx2*x0[2],x[t,3]-ax3-bx3*x0[3])
  	}
  return(list(mt=A[2],Ct=R[2,2]))
}

sampleMU_PS3d = function(M,W,mu,t){
  P   = W[1,2:6]%*%solve(W[2:6,2:6])
  H   = W[1,1]-P%*%W[2:6,1]
  	h   = M[1] + P%*%	c(mu-a-b*M[1],r[t+1]-M[1],x[t+1,1]-ax1-bx1*x[t,1],x[t+1,2]-ax2-bx2*x[t,2],x[t+1,3]-ax3-bx3*x[t,3])
  out = rnorm(1,h,sqrt(H))
  return(out)
}


#######################################
#######################################
sampleCOEF_MU_3d_TV = function(MU,Sigma,m0,C0){
	MU = as.matrix(MU)
	res= cbind(R[2:n] - MU[1:(n-1)],x[2:n,1] - ax1 - bx1*x[1:(n-1),1],x[2:n,2] - ax2 - bx2*x[1:(n-1),2],x[2:n,3] - ax3 - bx3*x[1:(n-1),3])
    
    W = matrix(0,(n-1),(n-1))
    Y = rep(0,1,(n-1))
    
    for(t in 2:n){
    Sig.2 = matrix(c(Sigma[t,2,1],Sigma[t,2,3],Sigma[t,2,4],Sigma[t,2,5]),1,4,byrow=T)
	Y[t-1] = MU[t] - (Sig.2%*%solve(Sigma[t,c(1,3,4,5),c(1,3,4,5)]))%*%(res[t-1,]) 
	
	
	W[t-1,t-1] = Sigma[t,2,2] - Sig.2%*%solve(Sigma[t,c(1,3,4,5),c(1,3,4,5)])%*%t(Sig.2)
	}
	
	F = cbind(1,MU[1:(n-1)])
	
	V1 = solve(t(F)%*%solve(W)%*%F + solve(C0))
	M1 = V1%*%(t(F)%*%solve(W)%*%(Y) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}


#######################################
#######################################
sampleCOEF_X1_3d = function(MU,Sigma,m0,C0){
	auxMU = as.matrix(MU)
	res= cbind(R[2:n] - auxMU[1:(n-1)],auxMU[2:n] - a - b*auxMU[1:(n-1)],x[2:n,2] - ax2 - bx2*x[1:(n-1),2],x[2:n,3] - ax3 - bx3*x[1:(n-1),3])
    
    Sig.3 = matrix(c(Sigma[3,1],Sigma[2,3],Sigma[3,4],Sigma[3,5]),1,4,byrow=T)
	Y = x[2:n,1] - (Sig.3%*%solve(Sigma[c(1,2,4,5),c(1,2,4,5)]))%*%t(res) 
	F = cbind(1,x[1:(n-1),1])
	
	W = Sigma[3,3] - Sig.3%*%solve(Sigma[c(1,2,4,5),c(1,2,4,5)])%*%t(Sig.3)
	
	V1 = solve(t(F)%*%F/as.numeric(W) + solve(C0))
	M1 = V1%*%(t(F)%*%t(Y)/as.numeric(W) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}

#######################################
#######################################
sampleCOEF_X2_3d = function(MU,Sigma,m0,C0){
	auxMU = as.matrix(MU)
	res= cbind(R[2:n] - auxMU[1:(n-1)],auxMU[2:n] - a - b*auxMU[1:(n-1)],x[2:n,1] - ax1 - bx1*x[1:(n-1),1],x[2:n,3] - ax3 - bx3*x[1:(n-1),3])
    
    Sig.4 = matrix(c(Sigma[4,1],Sigma[4,2],Sigma[4,3],Sigma[4,5]),1,4,byrow=T)
	Y = x[2:n,2] - (Sig.4%*%solve(Sigma[c(1,2,3,5),c(1,2,3,5)]))%*%t(res) 
	F = cbind(1,x[1:(n-1),2])
	
	W = Sigma[4,4] - Sig.4%*%solve(Sigma[c(1,2,3,5),c(1,2,3,5)])%*%t(Sig.4)
	
	V1 = solve(t(F)%*%F/as.numeric(W) + solve(C0))
	M1 = V1%*%(t(F)%*%t(Y)/as.numeric(W) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}

#######################################
#######################################
sampleCOEF_X3_3d = function(MU,Sigma,m0,C0){
	auxMU = as.matrix(MU)
	res= cbind(R[2:n] - auxMU[1:(n-1)],auxMU[2:n] - a - b*auxMU[1:(n-1)],x[2:n,1] - ax1 - bx1*x[1:(n-1),1],x[2:n,2] - ax2 - bx2*x[1:(n-1),2])
    
    Sig.5 = matrix(c(Sigma[5,1],Sigma[5,2],Sigma[5,3],Sigma[5,4]),1,4,byrow=T)
	Y = x[2:n,3] - (Sig.5%*%solve(Sigma[c(1,2,3,4),c(1,2,3,4)]))%*%t(res) 
	F = cbind(1,x[1:(n-1),3])
	
	W = Sigma[5,5] - Sig.5%*%solve(Sigma[c(1,2,3,4),c(1,2,3,4)])%*%t(Sig.5)
	
	V1 = solve(t(F)%*%F/as.numeric(W) + solve(C0))
	M1 = V1%*%(t(F)%*%t(Y)/as.numeric(W) + solve(C0)%*%m0)
	
	out = M1 + t(chol(V1))%*%rnorm(2)
	return(out)
	}
	
#######################################
#######################################
SigmaFix_3d = function(dat,m0.1,c0.1,M0,C0,nu1,lam1,nu2,lam2,nu3,lam3,Sigma){
  n = dim(dat)[1]
  
  aux = t(chol(Sigma)) 
  #diag(aux) = 1
  #PHI = solve(aux)
  
  A = solve(aux)
  D = diag(1/diag(A))
  PHI = D%*%A
  
  
  
  phi21  = -PHI[2,1]
  phi31  = -PHI[3,1]
  phi32  = -PHI[3,2]
  
  
  par1  = (nu1+n)/2
  par2  = nu1*lam1 + sum((dat[,1])^2)
  sig11  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,2] - phi21*dat[,1]
  
  par1  = (nu2+n)/2
  par2  = nu2*lam2 + sum((lixo)^2)
  sig2.1  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,3] - phi31*dat[,1] - phi32*dat[,2]  
  
  par1  = (nu3+n)/2
  par2  = nu3*lam3 + sum((lixo)^2)
  sig3.12  = 1/rgamma(1,par1,par2/2)
  
  
  xx = sum(dat[,1]^2)
  C1 = 1/(1/c0.1 + xx/sig2.1)
  m1 = C1*(m0.1/c0.1 + sum(dat[,1]*dat[,2])/sig2.1) 
  
  aux21 = m1 + sqrt(C1)*rnorm(1)
  if(aux21<0) phi21 = aux21
  
  F = dat[,1:2]
  V1 = solve(t(F)%*%F/sig3.12 + solve(C0))
  M1 = V1%*%(t(F)%*%dat[,3]/sig3.12 + solve(C0)%*%M0)
	
  out = M1 + t(chol(V1))%*%rnorm(2)
  phi31 = out[1]
  phi32 = out[2]
  
  
  PHI[2,1] = -phi21
  PHI[3,1] = -phi31
  PHI[3,2] = -phi32
  
  D[1,1] = sqrt(sig11)
  D[2,2] = sqrt(sig2.1)
  D[3,3] = sqrt(sig3.12)
  
  A = solve(D)%*%PHI 
  L = solve(A)
  SigmaOUT = L%*%t(L)
    
  return(SigmaOUT)  	
	}

#######################################
#######################################
SigmaFix_5d = function(dat,m0.1,c0.1,M0,C0,nu1,lam1,nu2,lam2,nu3,lam3,nu4,lam4,nu5,lam5,Sigma){
  n = dim(dat)[1]
  
  aux = t(chol(Sigma)) 
  #diag(aux) = 1
  #PHI = solve(aux)
  
  A = solve(aux)
  D = diag(1/diag(A))
  PHI = D%*%A
  
  
  
  phi21  = -PHI[2,1]
  phi31  = -PHI[3,1]
  phi32  = -PHI[3,2]
  phi41  = -PHI[4,1]
  phi42  = -PHI[4,2]
  phi43  = -PHI[4,3]
  phi51  = -PHI[5,1]
  phi52  = -PHI[5,2]
  phi53  = -PHI[5,3]
  phi54  = -PHI[5,4]
  
  
  par1  = (nu1+n)/2
  par2  = nu1*lam1 + sum((dat[,1])^2)
  sig11  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,2] - phi21*dat[,1]
  
  par1  = (nu2+n)/2
  par2  = nu2*lam2 + sum((lixo)^2)
  sig2.1  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,3] - phi31*dat[,1] - phi32*dat[,2]  
  
  par1  = (nu3+n)/2
  par2  = nu3*lam3 + sum((lixo)^2)
  sig3.12  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,4] - phi41*dat[,1] - phi42*dat[,2] - phi43*dat[,3]  
  
  par1  = (nu4+n)/2
  par2  = nu4*lam4 + sum((lixo)^2)
  sig4.123  = 1/rgamma(1,par1,par2/2)
  
  lixo = dat[,5] - phi51*dat[,1] - phi52*dat[,2] - phi53*dat[,3]- phi54*dat[,4]  
  
  par1  = (nu5+n)/2
  par2  = nu5*lam5 + sum((lixo)^2)
  sig5.1234  = 1/rgamma(1,par1,par2/2)

 
  xx = sum(dat[,1]^2)
  C1 = 1/(1/c0.1 + xx/sig2.1)
  m1 = C1*(m0.1/c0.1 + sum(dat[,1]*dat[,2])/sig2.1) 
  
  aux21 = m1 + sqrt(C1)*rnorm(1)
  if(aux21<0) phi21 = aux21
  
  F = dat[,1:2]
  V1 = solve(t(F)%*%F/sig3.12 + solve(C0[1:2,1:2]))
  M1 = V1%*%(t(F)%*%dat[,3]/sig3.12 + solve(C0[1:2,1:2])%*%M0[1:2])
	
  out = M1 + t(chol(V1))%*%rnorm(2)
  phi31 = out[1]
  phi32 = out[2]
 
  F = dat[,1:3]
  V1 = solve(t(F)%*%F/sig4.123 + solve(C0[3:5,3:5]))
  M1 = V1%*%(t(F)%*%dat[,4]/sig4.123 + solve(C0[3:5,3:5])%*%M0[3:5])
	
  out = M1 + t(chol(V1))%*%rnorm(3)
  phi41 = out[1]
  phi42 = out[2]
  phi43 = out[3]
 
  F = dat[,1:4]
  V1 = solve(t(F)%*%F/sig5.1234 + solve(C0[6:9,6:9]))
  M1 = V1%*%(t(F)%*%dat[,5]/sig5.1234 + solve(C0[6:9,6:9])%*%M0[6:9])
	
  out = M1 + t(chol(V1))%*%rnorm(4)
  phi51 = out[1]
  phi52 = out[2]
  phi53 = out[3] 
  phi54 = out[4] 
  
  
  
  PHI[2,1] = -phi21
  PHI[3,1] = -phi31
  PHI[3,2] = -phi32
  PHI[4,1] = -phi41
  PHI[4,2] = -phi42
  PHI[4,3] = -phi43
  PHI[5,1] = -phi51
  PHI[5,2] = -phi52
  PHI[5,3] = -phi53
  PHI[5,4] = -phi54
  
  
  D[1,1] = sqrt(sig11)
  D[2,2] = sqrt(sig2.1)
  D[3,3] = sqrt(sig3.12)
  D[4,4] = sqrt(sig4.123)
  D[5,5] = sqrt(sig5.1234)
  
  A = solve(D)%*%PHI 
  L = solve(A)
  SigmaOUT = L%*%t(L)
    
  return(SigmaOUT)  	
	}






ComputePastorMEAN = function(alpha,beta,Sigma,k,qT,bT){
	Er = alpha/(1-beta)
	Ak = 1 + 1/k *(-1-beta*((1-beta^(k-1))/(1-beta)))
    Bk = 1 + 1/k*(-1-2*beta*((1-beta^(k-1))/(1-beta))+(beta^2)*((1-beta^(2*(k-1)))/(1-beta^2)))
    R2 = Sigma[2,2]/(Sigma[1,1]*(1-beta^2) + Sigma[2,2])
	dbar = sqrt(((1+beta)/(1-beta))*(R2/(1-R2)))
	rho = Sigma[1,2]/sqrt(Sigma[1,1]*Sigma[2,2])
	lixo = k*Sigma[1,1]*(1+2*dbar*rho*Ak+(dbar^2)*Bk)
	
	lixo = lixo + qT*((1-beta^k)/(1-beta))^2
	return(lixo)
	}
	
ComputePastorVAR = function(alpha,beta,Sigma,k,qT,bT){
	Er = alpha/(1-beta)
   	lixo = k*Er + ((1-beta^k)/(1-beta))*(bT-Er)	
	return(lixo)	
    }



ComputePastorComp = function(alpha,beta,Sigma,k,qT,bT){
	Er = alpha/(1-beta)
	Ak = 1 + 1/k *(-1-beta*((1-beta^(k-1))/(1-beta)))
    Bk = 1 + 1/k*(-1-2*beta*((1-beta^(k-1))/(1-beta))+(beta^2)*((1-beta^(2*(k-1)))/(1-beta^2)))
    R2 = Sigma[2,2]/(Sigma[1,1]*(1-beta^2) + Sigma[2,2])
	dbar = sqrt(((1+beta)/(1-beta))*(R2/(1-R2)))
	rho = Sigma[1,2]/sqrt(Sigma[1,1]*Sigma[2,2])
	
	lixo1 = k*Sigma[1,1]
	lixo2 = k*Sigma[1,1]*2*dbar*rho*Ak
	lixo3 = k*Sigma[1,1]*(dbar^2)*Bk
	lixo4 = qT*((1-beta^k)/(1-beta))^2

	
	return(list=c(iid=lixo1,mrev=lixo2,futmu = lixo3,curmu = lixo4))
}

